package com.inca.npbusi.sales.bms_group_sa_doc;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.COtherquerycontrol;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.datacheck.checkprice.Npbusicheckprice;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.ApproveDialog;
import com.inca.pubsrv.CreateInvnoDialog;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;
import javax.swing.JOptionPane;

public class Bms_sales_mde extends CMdeModelAp implements ActionListener {
   private ApproveDialog a;
   private String b = "";
   private String c = "";
   protected String nosapriceinfo = "";

   public String getEntryid() {
      return this.b;
   }

   public void setEntryid(String var1) {
      this.b = var1;
   }

   public String getEntryname() {
      return this.c;
   }

   public void setEntryname(String var1) {
      this.c = var1;
   }

   public Bms_sales_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setSaveimmdiate(true);
      this.setResetbeforenew(true);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
      this.nosapriceinfo = NpbusiDBHelper.getSysParaConfig(this.b, "nosapriceinfo");
   }

   protected CMasterModel createMastermodel() {
      return new Bms_sales_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_sales_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "salesid";
   }

   public String getDetailRelatecolname() {
      return "salesid";
   }

   public String getSaveCommandString() {
      return "Bms_sales_mde.跨独立单元开票";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("发货保管账集合", ""));
      var1.add(new Apinfo("授权独立单元", ""));
      var1.add(new Apinfo("销售模式", ""));
      var1.add(new Apinfo("结算方式", ""));
      var1.add(new Apinfo("准许出库配货", ""));
      var1.add(new Apinfo("自动出库配货", ""));
      var1.add(new Apinfo("自动出库记保管账", ""));
      var1.add(new Apinfo("自动缺货登记", ""));
      var1.add(new Apinfo("库存是否选择到批号、批次、货位由销售控制", ""));
      var1.add(new Apinfo("库存选择到货位", ""));
      var1.add(new Apinfo("库存选择到货品状态", ""));
      var1.add(new Apinfo("自提允许配货", ""));
      var1.add(new Apinfo("禁止审批", "1"));
      var1.add(new Apinfo("禁止确定", "1"));
      var1.add(new Apinfo("禁止回退提交", ""));
      var1.add(new Apinfo("禁止回退确定", "1"));
      var1.add(new Apinfo("禁止作废", "1"));
      var1.add(new Apinfo("是否提示选择老批次", "1"));
      var1.add(new Apinfo("非严格控制批次禁销限销", ""));
      var1.add(new Apinfo("Hov显示价格类型", ""));
      var1.add(new Apinfo("是否提示老批号", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("审批")) {
         var1 = this.getApvalue("禁止审批");
         if ("1".equals(var1)) {
            this.infoMessage("提示", "没有审批权限不能审批！");
            return -1;
         } else {
            Bms_sales_mde var11 = this;
            if (this.getMasterModel().getRow() < 0) {
               this.warnMessage("警告", "请选择正确的单据进行审批!");
            } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
               this.warnMessage("警告", "请选择正确的单据进行审批!");
            } else {
               for(int var2 = 0; var2 < var11.getMasterModel().getRowCount(); ++var2) {
                  if (var11.getMasterModel().getdbStatus(var2) != 0) {
                     var11.warnMessage("警告", "没有保存不能审批,请先保存!");
                     return 0;
                  }
               }

               String var10 = var11.getMasterModel().getItemValue(var11.getMasterModel().getRow(), "usestatus");
               if (!"2".equals(var10)) {
                  var11.warnMessage("警告", "销售发货单不是临时状态，不能审批！");
               } else {
                  var10 = var11.getMasterModel().getItemValue(var11.getMasterModel().getRow(), "approveflag");
                  if (!"2".equals(var10)) {
                     var11.warnMessage("警告", "销售发货单不是待审批状态，不能审批！");
                  } else {
                     var10 = var11.getMasterModel().getItemValue(var11.getMasterModel().getRow(), "salesid");
                     String var3 = "";
                     DBTableModel var4 = null;
                     String var5 = " select savememo from bms_sa_approve_memo where sourceid= " + var10 + " and comefrom = 3";
                     RemotesqlHelper var6 = new RemotesqlHelper();

                     try {
                        var4 = var6.doSelect(var5, 0, 1);
                     } catch (Exception var9) {
                        var9.printStackTrace();
                     }

                     if (var4 != null && var4.getRowCount() > 0) {
                        var3 = var4.getItemValue(0, "savememo");
                     }

                     ClientRequest var15 = new ClientRequest();
                     StringCommand var14 = new StringCommand("跨独立单元开票.销售发货单提交");
                     Vector var16 = new Vector();
                     DBColumnDisplayInfo var7 = new DBColumnDisplayInfo("salesid", "number");
                     var16.add(var7);
                     var7 = new DBColumnDisplayInfo("message", "varchar");
                     var16.add(var7);
                     var7 = new DBColumnDisplayInfo("approvememo", "varchar");
                     var16.add(var7);
                     var7 = new DBColumnDisplayInfo("isCommit", "varchar");
                     var16.add(var7);
                     DBTableModel var17;
                     (var17 = new DBTableModel(var16)).appendRow();
                     var17.setItemValue(0, "salesid", var10);
                     var17.setItemValue(0, "isCommit", "0");
                     DataCommand var12;
                     (var12 = new DataCommand()).setDbmodel(var17);
                     var15.addCommand(var14);
                     var15.addCommand(var12);
                     var10 = null;

                     try {
                        ServerResponse var13;
                        if ((var14 = (StringCommand)(var13 = SendHelper.sendRequest(var15)).commandAt(0)).getString().startsWith("+OK")) {
                           var10 = ((DataCommand)var13.commandAt(1)).getDbmodel().getItemValue(0, "approvememo");
                           var11.a = new ApproveDialog(var11.frame, "销售发货单审批", var11);
                           var11.a.pack();
                           var11.a.setLocation((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth() - (double)var11.a.getWidth()) / 2.0), (int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight() - (double)var11.a.getHeight()) / 2.0));
                           var11.a.setVisible(true);
                           var11.a.getappcheckarea().setText(var10);
                           var11.a.getcommitcheckarea().setText(var3);
                        } else {
                           var11.errorMessage("错误", "审批不成功原因:" + var14.getString());
                        }
                     } catch (Exception var8) {
                        var11.errorMessage("错误", "审批不成功原因:" + var8.getMessage());
                        var8.printStackTrace();
                     }
                  }
               }
            }

            return 0;
         }
      } else if (var1.equals("确定")) {
         var1 = this.getApvalue("禁止确定");
         if ("1".equals(var1)) {
            this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
            return -1;
         } else {
            this.c();
            return 0;
         }
      } else if (var1.equals("回退确定")) {
         var1 = this.getApvalue("禁止回退确定");
         if ("1".equals(var1)) {
            this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
            return -1;
         } else {
            this.a();
            return 0;
         }
      } else if (var1.equals("作废")) {
         var1 = this.getApvalue("禁止作废");
         if ("1".equals(var1)) {
            this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
            return -1;
         } else {
            this.b();
            return 0;
         }
      } else if (var1.equals("生成发票")) {
         this.e();
         return 0;
      } else if (var1.equals("切换独立单元")) {
         if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
            this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
            return -1;
         } else {
            var1 = this.getApvalue("授权独立单元");
            if (Entrychose.setUserEntryInfo(this.frame, var1)) {
               this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
               this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
               this.getMasterModel().doRetrieve("1=2");
               this.nosapriceinfo = NpbusiDBHelper.getSysParaConfig(this.b, "nosapriceinfo");
            }

            return 0;
         }
      } else if (var1.equals("回退提交")) {
         var1 = this.getApvalue("禁止回退提交");
         if ("1".equals(var1)) {
            this.infoMessage("提示", "对不起，您没有执行此操作的权限！");
            return -1;
         } else {
            this.d();
            return 0;
         }
      } else {
         return super.on_actionPerformed(var1);
      }
   }

   private void a() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行回退确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行回退确定!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能回退确定,请先保存!");
               return;
            }
         }

         String var10 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"1".equals(var10)) {
            this.warnMessage("警告", "销售发货单不是正式状态，不能回退确定！");
         } else {
            var10 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "comefrom");
            if (!"1".equals(var10)) {
               this.warnMessage("警告", "销售发货单不是手工录入，不能回退确定！");
            } else {
               ClientRequest var11 = new ClientRequest();
               StringCommand var2 = new StringCommand("跨独立单元开票.销售发货单回退确定");
               String var3 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
               Vector var4 = new Vector();
               DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("salesid", "number");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("message", "varchar");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("usestatus", "number");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("confirmaname", "varchar");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("confirmdate", "date");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("confirmanid", "number");
               var4.add(var5);
               DBTableModel var13;
               (var13 = new DBTableModel(var4)).appendRow();
               var13.setItemValue(0, "salesid", var3);
               DataCommand var14;
               (var14 = new DataCommand()).setDbmodel(var13);
               var11.addCommand(var2);
               var11.addCommand(var14);
               this.setWaitCursor();
               var2 = null;

               try {
                  ServerResponse var12 = SendHelper.sendRequest(var11);
                  this.a(var12, "回退确定", 2, 5);
                  this.getDetailModel().doRetrieve("salesid = " + var3);
                  return;
               } catch (Exception var8) {
                  this.errorMessage("错误", "回退确定不成功原因:" + var8.getMessage());
                  var8.printStackTrace();
               } finally {
                  this.setDefaultCursor();
               }

            }
         }
      }
   }

   private void b() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0 && var1 != this.getMasterModel().getDBtableModel().getRowCount()) {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.warnMessage("警告", "没有保存不能作废,请先保存!");
               return;
            }
         }

         if (this.getDetailModel().getRow() < 0) {
            this.warnMessage("警告", "请选择正确的单据进行作废!");
         } else if (this.getDetailModel().getRow() == this.getDetailModel().getDBtableModel().getRowCount()) {
            this.warnMessage("警告", "请选择正确的单据进行作废!");
         } else {
            int[] var16;
            int var3 = (var16 = this.getDetailModel().getTable().getSelectedRows()).length;
            if (this.getDetailModel().getTable().getSelectedRow() == this.getDetailModel().getTable().getRowCount() - 1) {
               this.warnMessage("警告", "选中行错误,请重新选择!!!");
            } else {
               if (var16[var16.length - 1] == this.getDetailModel().getRowCount()) {
                  --var3;
               }

               String var14 = this.getMasterModel().getItemValue(var1, "salesid");
               Vector var4 = new Vector();
               DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("salesid", "number");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("message", "varchar");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("salesdtlid", "number");
               var4.add(var5);
               var5 = new DBColumnDisplayInfo("preparestatus", "number");
               var4.add(var5);
               DBTableModel var19 = new DBTableModel(var4);

               for(int var21 = 0; var21 < var3; ++var21) {
                  if (this.getDetailModel().getdbStatus(var16[var21]) != 0) {
                     this.warnMessage("警告", "第" + (var16[var21] + 1) + "行细单没有保存不能作废,请先保存!");
                     return;
                  }

                  String var6 = this.getDetailModel().getItemValue(var16[var21], "salesdtlid");
                  if (!this.detailmodel.getItemValue(var16[var21], "correctflag").equals("0")) {
                     this.warnMessage("警告", "第" + (var16[var21] + 1) + "行细单的冲调标志不是\"正常\"状态,不能作废！");
                     return;
                  }

                  String var8 = this.getDetailModel().getItemValue(var16[var21], "stioflag");
                  if ("1".equals(var8)) {
                     this.warnMessage("警告", "第" + (var16[var21] + 1) + "行细单已经出库记账,不能作废！");
                     return;
                  }

                  int var9 = var19.getRowCount();
                  var19.appendRow();
                  var19.setItemValue(var9, "salesid", var14);
                  var19.setItemValue(var9, "salesdtlid", var6);
               }

               if (var19.getRowCount() > 0) {
                  ClientRequest var23 = new ClientRequest();
                  DataCommand var22;
                  (var22 = new DataCommand()).setDbmodel(var19);
                  var23.addCommand(new StringCommand("跨独立单元开票.销售发货单作废"));
                  var23.addCommand(var22);
                  this.setWaitCursor();
                  ServerResponse var7 = null;

                  try {
                     StringCommand var25 = (StringCommand)(var7 = SendHelper.sendRequest(var23)).commandAt(0);
                     String var26 = "";
                     if (var25.getString().startsWith("+OK")) {
                        DBTableModel var15 = ((DataCommand)var7.commandAt(1)).getDbmodel();
                        String var17 = "";
                        boolean var18 = false;

                        for(int var20 = 0; var20 < var15.getRowCount(); ++var20) {
                           String var24;
                           if (!var18 && (var24 = var15.getItemValue(var20, "preparestatus")) != null && var24.equals("1")) {
                              var18 = true;
                           }

                           var24 = var15.getItemValue(var20, "message");
                           var26 = var24 + "\n";
                           if (!var24.startsWith("+OK")) {
                              var17 = var17 + var15.getItemValue(var20, "salesdtlid") + "、";
                           }
                        }

                        if ("".equals(var17)) {
                           if (var18) {
                              this.infoMessage("提示", "作废成功!\n库房已经配货，请立即通知库房！");
                           } else {
                              this.infoMessage("提示", "作废成功！");
                           }
                        } else {
                           this.infoMessage("提示", "ID为" + var17.substring(0, var17.length() - 1) + "的细单作废失败！\n" + var26);
                        }
                     } else {
                        this.errorMessage("错误", "作废不成功,原因:" + var25.getString());
                     }
                  } catch (Exception var12) {
                     var12.printStackTrace();
                     this.errorMessage("错误", "作废不成功,原因:" + var12.getMessage());
                  } finally {
                     this.setDefaultCursor();
                  }

                  this.getMasterModel().doRequery();
               }
            }
         }
      } else {
         this.warnMessage("警告", "请选择正确的单据进行作废!");
      }
   }

   private void c() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         this.getMasterModel().getTable().getSelectedRows();
         String var10 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
         String var2 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if ("2".equals(var10)) {
            this.warnMessage("警告", "请先审批！");
         } else if (!"2".equals(var2)) {
            this.warnMessage("警告", "不是临时状态，不能确定！");
         } else {
            var10 = this.mastermodel.getItemValue(this.mastermodel.getRow(), "entryid");

            String var3;
            int var11;
            for(var11 = 0; var11 < this.detailmodel.getRowCount(); ++var11) {
               var3 = this.getDetailModel().getItemValue(var11, "unitprice");
               if (!Npbusicheckprice.fitPrice(this.getDetailModel().getItemValue(var11, "goodsid"), var3, 2, var10)) {
                  if (JOptionPane.showConfirmDialog(this.frame, "销售价格应高于批发最低限价，低于国家零售价\n是否继续") != 0) {
                     return;
                  }
                  break;
               }
            }

            String var4;
            for(var11 = 0; var11 < this.getDetailModel().getRowCount(); ++var11) {
               var3 = this.getDetailModel().getItemValue(var11, "unitprice");
               var4 = this.getDetailModel().getItemValue(var11, "taxbatchprice");
               if (DecimalHelper.comparaDecimal(var3, var4) < 0 && JOptionPane.showConfirmDialog(this.frame, "细单第" + (var11 + 1) + " 行数据的单价比含税批次价低，是否继续?", "提示", 0) != 0) {
                  return;
               }
            }

            ClientRequest var15 = new ClientRequest();
            StringCommand var16 = new StringCommand("跨独立单元开票.销售发货单确定");
            var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
            Vector var12 = new Vector();
            DBColumnDisplayInfo var5 = new DBColumnDisplayInfo("salesid", "number");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("message", "varchar");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("autofix", "varchar");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("autokeep", "varchar");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("usestatus", "number");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("confirmaname", "varchar");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("confirmdate", "date");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("confirmanid", "number");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("approveflag", "number");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("allowfix", "number");
            var12.add(var5);
            var5 = new DBColumnDisplayInfo("autofixraise", "number");
            var12.add(var5);
            DBTableModel var13;
            (var13 = new DBTableModel(var12)).appendRow();
            var13.setItemValue(0, "salesid", var4);
            var13.setItemValue(0, "allowfix", this.getApvalue("准许出库配货"));
            var13.setItemValue(0, "autofix", this.getApvalue("自动出库配货"));
            var13.setItemValue(0, "autokeep", this.getApvalue("自动出库记保管账"));
            var13.setItemValue(0, "autofixraise", this.getApvalue("自提允许配货"));
            DataCommand var17;
            (var17 = new DataCommand()).setDbmodel(var13);
            var15.addCommand(var16);
            var15.addCommand(var17);
            var15.addCommand(new StringCommand(this.getEntryid()));
            this.setWaitCursor();
            var10 = null;

            try {
               ServerResponse var14 = SendHelper.sendRequest(var15);
               this.a(var14, "确定", 4, 8);
               this.detailmodel.doRetrieve("salesid = " + var4);
               return;
            } catch (Exception var8) {
               this.errorMessage("错误", "确定不成功原因:" + var8.getMessage());
               var8.printStackTrace();
            } finally {
               this.setDefaultCursor();
            }

         }
      }
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getActionCommand().equals("diglog-ok")) {
         if (this.a.getappacross().isSelected()) {
            this.a(true);
         }

         if (this.a.getbackcommit().isSelected()) {
            this.a(false);
         }

         this.a.getnoapp().isSelected();
      }

      super.actionPerformed(var1);
   }

   private void a(boolean var1) {
      String var2 = this.a.getappmemoarea().getText();
      String var3 = this.a.getappcheckarea().getText();
      String var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
      String var5 = "0";
      if (var1) {
         var5 = "1";
      }

      StringCommand var13 = new StringCommand("跨独立单元开票.销售发货单审批");
      ClientRequest var6 = new ClientRequest();
      Vector var7 = new Vector();
      DBColumnDisplayInfo var8 = new DBColumnDisplayInfo("salesid", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("message", "varchar");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approve", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("appcheckinfo", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approveflag", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvemanname", "varchar");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvemanid", "number");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvedate", "date");
      var7.add(var8);
      var8 = new DBColumnDisplayInfo("approvememo", "varchar");
      var7.add(var8);
      DBTableModel var16;
      (var16 = new DBTableModel(var7)).appendRow();
      var16.setItemValue(0, "salesid", var4);
      var16.setItemValue(0, "approve", var5);
      var16.setItemValue(0, "approvememo", var2);
      var16.setItemValue(0, "appcheckinfo", var3);
      DataCommand var15;
      (var15 = new DataCommand()).setDbmodel(var16);
      var6.addCommand(var13);
      var6.addCommand(var15);
      this.setWaitCursor();
      var13 = null;

      try {
         ServerResponse var14 = SendHelper.sendRequest(var6);
         this.a(var14, "审批", 4, 8);
         return;
      } catch (Exception var11) {
         this.errorMessage("错误", "审批不成功原因:" + var11.getMessage());
         var11.printStackTrace();
      } finally {
         this.setDefaultCursor();
      }

   }

   private void a(ServerResponse var1, String var2, int var3, int var4) {
      String var5;
      if (!(var5 = var1.getCommand()).startsWith("+OK")) {
         this.errorMessage("错误", var5);
      } else {
         DBTableModel var13 = this.getMasterModel().getDBtableModel();
         DBTableModel var12;
         int var6 = (var12 = ((DataCommand)var1.commandAt(1)).getDbmodel()).getColumnCount();

         for(int var7 = 0; var7 < var12.getRowCount(); ++var7) {
            String var8 = var12.getItemValue(var7, "salesid");
            String var9 = var12.getItemValue(var7, "message");

            for(int var10 = 0; var10 < var13.getRowCount(); ++var10) {
               if (var13.getItemValue(var10, "salesid").equals(var8)) {
                  String var11;
                  int var14;
                  if (var9.startsWith("+OK")) {
                     for(var14 = var3; var14 <= var4 && var14 < var6; ++var14) {
                        var11 = var12.getColumnDBName(var14);
                        var13.setItemValue(var10, var11, var12.getItemValue(var7, var11));
                        if (var2.equals("回退确定")) {
                           var13.setItemValue(var10, "approvemanid", "");
                           var13.setItemValue(var10, "approvedate", "");
                           var13.setItemValue(var10, "approvememo", "");
                           var13.setItemValue(var10, "approveflag", "0");
                        }
                     }

                     var13.setdbStatus(var10, 0);
                     var13.getRecordThunk(var10).setSaveresult(0, var2 + "成功");
                  } else if (var9.startsWith("-ERROR")) {
                     var13.getRecordThunk(var10).setSaveresult(1, var9);
                  } else if (var9.startsWith("-INFO")) {
                     for(var14 = var3; var14 <= var4 && var14 < var6; ++var14) {
                        var11 = var12.getColumnDBName(var14);
                        var13.setItemValue(var10, var11, var12.getItemValue(var7, var11));
                     }

                     var13.setdbStatus(var10, 0);
                     var13.getRecordThunk(var10).setSaveresult(1, var9);
                  }

                  if (var2.equals("确定") && var9.startsWith("+OK1")) {
                     var13.getRecordThunk(var10).setSaveresult(0, var2 + "成功!有赠品出库单生成，请注意检查!");
                  }
                  break;
               }
            }
         }

         this.getMasterModel().tableChanged();
         this.getDetailModel().tableChanged();
      }
   }

   protected boolean chkCompanyLicense(String var1, String var2, String var3, String var4, int var5) {
      ClientRequest var6 = new ClientRequest();
      StringCommand var7 = new StringCommand("证照管理:证照期限检查");
      ParamCommand var8 = new ParamCommand();
      String var9 = null;
      String var10 = null;
      boolean var11 = true;
      var8.addParam("companyid", var1);
      var8.addParam("goodsid", var2);
      var8.addParam("permitoverdays", var3);
      var8.addParam("warndays", var4);
      var6.addCommand(var7);
      var6.addCommand(var8);
      ServerResponse var12;
      if (((StringCommand)(var12 = SendHelper.sendRequest(var6)).commandAt(0)).getString().startsWith("+OK")) {
         ParamCommand var13;
         var9 = (var13 = (ParamCommand)var12.commandAt(1)).getValue("message");
         var10 = var13.getValue("flag");
         if (var9 != null && var9.length() > 0) {
            this.infoMessage("提示", var9);
         }
      }

      if (var10 != null && var10.equals("0")) {
         var11 = false;
      }

      if (var11) {
         return true;
      } else {
         if (var2 != null && var2.length() != 0) {
            this.detailmodel.setItemValue(var5, "opcode", "");
            this.detailmodel.setItemValue(var5, "goodsid", "");
            this.detailmodel.setItemValue(var5, "goodsname", "");
            this.detailmodel.setItemValue(var5, "goodsno", "");
            this.detailmodel.setItemValue(var5, "goodsunit", "");
            this.detailmodel.setItemValue(var5, "goodsdtlid", "");
            this.detailmodel.setItemValue(var5, "currencyname", "");
            this.detailmodel.setItemValue(var5, "factoryname", "");
            this.detailmodel.setItemValue(var5, "prodarea", "");
            this.detailmodel.setItemValue(var5, "packsize", "");
            this.detailmodel.setItemValue(var5, "packname", "");
            this.detailmodel.setItemValue(var5, "goodstype", "");
         } else {
            this.mastermodel.setItemValue(var5, "customopcode", "");
            this.mastermodel.setItemValue(var5, "customid", "");
            this.mastermodel.setItemValue(var5, "customno", "");
            this.mastermodel.setItemValue(var5, "customname", "");
         }

         return false;
      }
   }

   public void doNew() {
      this.detailmodel.commitEdit();
      int var1 = this.detailmodel.getModifiedDbmodel().getRowCount();
      int var2 = 0;

      while(var2 < var1) {
         String var3;
         if ((var3 = this.detailmodel.getModifiedDbmodel().getItemValue(var2, "unitprice")) != null && !"".equals(var3)) {
            if ((var3 = this.detailmodel.getModifiedDbmodel().getItemValue(var2, "goodsuseunit")) != null && !"".equals(var3)) {
               if ((var3 = this.detailmodel.getModifiedDbmodel().getItemValue(var2, "goodsuseqty")) != null && !"".equals(var3)) {
                  if ((var3 = this.detailmodel.getModifiedDbmodel().getItemValue(var2, "discount")) != null && !"".equals(var3)) {
                     ++var2;
                     continue;
                  }

                  this.infoMessage("提示", "数据项‘折扣’不能为空!");
                  return;
               }

               this.infoMessage("提示", "数据项‘使用单位数量’不能为空!");
               return;
            }

            this.infoMessage("提示", "数据项‘使用单位’不能为空!");
            return;
         }

         this.infoMessage("提示", "数据项‘单价’不能为空！");
         return;
      }

      super.doNew();
   }

   private void d() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         String var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "approveflag");
         String var2 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"2".equals(var4)) {
            this.warnMessage("警告", "不是待审批状态，不能回退提交！");
         } else if (!"2".equals(var2)) {
            this.warnMessage("警告", "不是临时状态，不能回退提交！");
         } else {
            var4 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "salesid");
            ClientRequest var5;
            (var5 = new ClientRequest()).addCommand(new StringCommand("跨独立单元开票.doBackSubmit.回退提交"));
            var5.addCommand(new StringCommand(var4));
            ServerResponse var6 = null;

            try {
               var6 = SendHelper.sendRequest(var5);
            } catch (Exception var3) {
               var3.printStackTrace();
            }

            if ((var2 = ((StringCommand)var6.commandAt(0)).getString()).equals("+OK")) {
               this.getMasterModel().setItemValue(this.getMasterModel().getRow(), "approveflag", "0");
               this.getMasterModel().setdbStatus(this.getMasterModel().getRow(), 0);
               this.getMasterModel().getDBtableModel().getRecordThunk(this.getMasterModel().getRow()).setSaveresult(0, "回退提交完成！");
               this.getMasterModel().tableChanged();
            } else {
               this.errorMessage("错误", var2);
            }
         }
      }
   }

   private void e() {
      int var1;
      if ((var1 = this.getMasterModel().getRow()) >= 0) {
         int[] var2;
         if ((var2 = this.getDetailModel().getTable().getSelectedRows()).length > 0) {
            if (!this.getMasterModel().getItemValue(var1, "usestatus").equals("1")) {
               this.infoMessage("提示", "销售单不是正式状态，不能生成发票！");
            } else {
               for(var1 = 0; var1 < var2.length; ++var1) {
                  String var3 = this.getDetailModel().getItemValue(var2[var1], "stioflag");
                  if ("1".equals(var3)) {
                     this.infoMessage("提示", "已经记帐，不用再生成发票！");
                     return;
                  }
               }

               CreateInvnoDialog var7;
               (var7 = new CreateInvnoDialog(this.frame, "生成销售发票", (COtherquerycontrol)null)).pack();
               var7.setVisible(true);
               ParamCommand var10 = new ParamCommand();
               var7.setParamValue(var10);
               ClientRequest var8;
               (var8 = new ClientRequest()).addCommand(new StringCommand("生成发票信息"));
               ParamCommand var4 = new ParamCommand();
               var8.addCommand(new StringCommand("bms_group_sa_dtl"));

               for(int var5 = 0; var5 < var2.length; ++var5) {
                  var4.addParam("ID_" + var5, "salesdtlid = " + this.getDetailModel().getItemValue(var2[var5], "salesdtlid"));
               }

               var8.addCommand(var4);
               var8.addCommand(var10);
               ServerResponse var11 = null;

               try {
                  var11 = SendHelper.sendRequest(var8);
               } catch (Exception var6) {
                  var6.printStackTrace();
               }

               StringCommand var9;
               if (!(var9 = (StringCommand)var11.commandAt(0)).getString().startsWith("+OK")) {
                  this.infoMessage("提示", "生成销售发票失败!原因为：" + var9.getString());
               } else {
                  for(var1 = 0; var1 < var2.length; ++var1) {
                     this.getDetailModel().setItemValue(var2[var1], "invdate", var10.getValue("invdate"));
                     this.getDetailModel().setItemValue(var2[var1], "invno", var10.getValue("invno"));
                     this.getDetailModel().setdbStatus(var2[var1], 0);
                  }

                  this.infoMessage("提示", "生成销售发票成功!");
               }
            }
         }
      }
   }
}
